<?php
/* Autor...: William L. Taype Perez */
/* Esquema.: MST_ClaseSubFamilia.xml */
/* Generado: 2021-11-19 07:55:32 */

/* Mantenimiento de los registros de la tabla MST_ClaseSubFamilia */
abstract class BaseMST_ClaseSubFamiliaDP extends MST_ClaseSubFamiliaBV
{
    /* Constructor ( Establece los valores desde un objeto MST_ClaseSubFamiliaBN ) */
    public function __construct( MST_ClaseSubFamiliaBN $o_MST_ClaseSubFamiliaBN = null )
    {
        parent::__construct();
        if ( !is_null( $o_MST_ClaseSubFamiliaBN ) )
        {
            $this->setByBN( $o_MST_ClaseSubFamiliaBN );
        }
    }

    public $b_Debug = false;

    public function getDebug()
    {
        if( SF_DEBUG )
        {
            $this->b_Debug = true;
        }
        return $this->b_Debug;
    }

    public function setDebug( $v )
    {
        $this->b_Debug = $v;
    }

    /* Establece los valores desde un objeto MST_ClaseSubFamiliaBN */
    public function setByBN( MST_ClaseSubFamiliaBN $o_MST_ClaseSubFamiliaBN )
    {
        if ( !is_null( $o_MST_ClaseSubFamiliaBN->getIdSubFamilia() ) )
        {
            $this->setIdSubFamilia( $o_MST_ClaseSubFamiliaBN->getIdSubFamilia() );
        }
        if ( !is_null( $o_MST_ClaseSubFamiliaBN->getIdLinea() ) )
        {
            $this->setIdLinea( $o_MST_ClaseSubFamiliaBN->getIdLinea() );
        }
        if ( !is_null( $o_MST_ClaseSubFamiliaBN->getIdFamilia() ) )
        {
            $this->setIdFamilia( $o_MST_ClaseSubFamiliaBN->getIdFamilia() );
        }
        if ( !is_null( $o_MST_ClaseSubFamiliaBN->getDescripcion() ) )
        {
            $this->setDescripcion( $o_MST_ClaseSubFamiliaBN->getDescripcion() );
        }
        if ( !is_null( $o_MST_ClaseSubFamiliaBN->getUrlAmigable() ) )
        {
            $this->setUrlAmigable( $o_MST_ClaseSubFamiliaBN->getUrlAmigable() );
        }
        if ( !is_null( $o_MST_ClaseSubFamiliaBN->getCodigo() ) )
        {
            $this->setCodigo( $o_MST_ClaseSubFamiliaBN->getCodigo() );
        }
        if ( !is_null( $o_MST_ClaseSubFamiliaBN->getEsParaAlquiler() ) )
        {
            $this->setEsParaAlquiler( $o_MST_ClaseSubFamiliaBN->getEsParaAlquiler() );
        }
        if ( !is_null( $o_MST_ClaseSubFamiliaBN->getEsParaVenta() ) )
        {
            $this->setEsParaVenta( $o_MST_ClaseSubFamiliaBN->getEsParaVenta() );
        }
        if ( !is_null( $o_MST_ClaseSubFamiliaBN->getIdRangoAlquiler() ) )
        {
            $this->setIdRangoAlquiler( $o_MST_ClaseSubFamiliaBN->getIdRangoAlquiler() );
        }
        if ( !is_null( $o_MST_ClaseSubFamiliaBN->getIdRangoVenta() ) )
        {
            $this->setIdRangoVenta( $o_MST_ClaseSubFamiliaBN->getIdRangoVenta() );
        }
        if ( !is_null( $o_MST_ClaseSubFamiliaBN->getTieneDescuentoAdelanto() ) )
        {
            $this->setTieneDescuentoAdelanto( $o_MST_ClaseSubFamiliaBN->getTieneDescuentoAdelanto() );
        }
        if ( !is_null( $o_MST_ClaseSubFamiliaBN->getTieneDescuentoContado() ) )
        {
            $this->setTieneDescuentoContado( $o_MST_ClaseSubFamiliaBN->getTieneDescuentoContado() );
        }
        if ( !is_null( $o_MST_ClaseSubFamiliaBN->getIdRangoDescuentoContado() ) )
        {
            $this->setIdRangoDescuentoContado( $o_MST_ClaseSubFamiliaBN->getIdRangoDescuentoContado() );
        }
        if ( !is_null( $o_MST_ClaseSubFamiliaBN->getIdRengoDescuentoAdelanto() ) )
        {
            $this->setIdRengoDescuentoAdelanto( $o_MST_ClaseSubFamiliaBN->getIdRengoDescuentoAdelanto() );
        }
        if ( !is_null( $o_MST_ClaseSubFamiliaBN->getEstado() ) )
        {
            $this->setEstado( $o_MST_ClaseSubFamiliaBN->getEstado() );
        }
        if ( !is_null( $o_MST_ClaseSubFamiliaBN->getFechaCreacion() ) )
        {
            $this->setFechaCreacion( $o_MST_ClaseSubFamiliaBN->getFechaCreacion() );
        }
        if ( !is_null( $o_MST_ClaseSubFamiliaBN->getNombreArchivo() ) )
        {
            $this->setNombreArchivo( $o_MST_ClaseSubFamiliaBN->getNombreArchivo() );
        }
        if ( !is_null( $o_MST_ClaseSubFamiliaBN->getUbicacionURL() ) )
        {
            $this->setUbicacionURL( $o_MST_ClaseSubFamiliaBN->getUbicacionURL() );
        }
        if ( !is_null( $o_MST_ClaseSubFamiliaBN->getUbicacionFisica() ) )
        {
            $this->setUbicacionFisica( $o_MST_ClaseSubFamiliaBN->getUbicacionFisica() );
        }
        if ( !is_null( $o_MST_ClaseSubFamiliaBN->getUsuarioCreacion() ) )
        {
            $this->setUsuarioCreacion( $o_MST_ClaseSubFamiliaBN->getUsuarioCreacion() );
        }
        if ( !is_null( $o_MST_ClaseSubFamiliaBN->getFechaModificacion() ) )
        {
            $this->setFechaModificacion( $o_MST_ClaseSubFamiliaBN->getFechaModificacion() );
        }
        if ( !is_null( $o_MST_ClaseSubFamiliaBN->getUsuarioModificacion() ) )
        {
            $this->setUsuarioModificacion( $o_MST_ClaseSubFamiliaBN->getUsuarioModificacion() );
        }
    }

    /* Graba un nuevo registro */
    public function save()
    {
        $this->validateRecord();
        $o_MST_ClaseSubFamiliaFN = new MST_ClaseSubFamiliaFN();
        $o_MST_ClaseSubFamiliaBN = $o_MST_ClaseSubFamiliaFN->selectByPk( $this->getIdSubFamilia() );
        if ( is_null( $o_MST_ClaseSubFamiliaBN ) )
        {
            $s_SQLQuery1 = "INSERT INTO MST_ClaseSubFamilia ( ";
            $s_SQLQuery2 = "VALUES ( ";
            $s_Separator = "";
            if ( !is_null( $this->getIdSubFamilia() ) )
            {
                $s_SQLQuery1 .= $s_Separator."IdSubFamilia";
                $s_SQLQuery2 .= $s_Separator."".$this->getIdSubFamilia()."";
                $s_Separator = ", ";
            }
            if ( !is_null( $this->getIdLinea() ) )
            {
                $s_SQLQuery1 .= $s_Separator."IdLinea";
                $s_SQLQuery2 .= $s_Separator."".$this->getIdLinea()."";
                $s_Separator = ", ";
            }
            if ( !is_null( $this->getIdFamilia() ) )
            {
                $s_SQLQuery1 .= $s_Separator."IdFamilia";
                $s_SQLQuery2 .= $s_Separator."".$this->getIdFamilia()."";
                $s_Separator = ", ";
            }
            if ( !is_null( $this->getDescripcion() ) )
            {
                $s_SQLQuery1 .= $s_Separator."Descripcion";
                $s_SQLQuery2 .= $s_Separator."'".$this->getDescripcion()."'";
                $s_Separator = ", ";
            }
            if ( !is_null( $this->getUrlAmigable() ) )
            {
                $s_SQLQuery1 .= $s_Separator."UrlAmigable";
                $s_SQLQuery2 .= $s_Separator."'".$this->getUrlAmigable()."'";
                $s_Separator = ", ";
            }
            if ( !is_null( $this->getCodigo() ) )
            {
                $s_SQLQuery1 .= $s_Separator."Codigo";
                $s_SQLQuery2 .= $s_Separator."'".$this->getCodigo()."'";
                $s_Separator = ", ";
            }
            if ( !is_null( $this->getEsParaAlquiler() ) )
            {
                $s_SQLQuery1 .= $s_Separator."EsParaAlquiler";
                $s_SQLQuery2 .= $s_Separator."'".$this->getEsParaAlquiler()."'";
                $s_Separator = ", ";
            }
            if ( !is_null( $this->getEsParaVenta() ) )
            {
                $s_SQLQuery1 .= $s_Separator."EsParaVenta";
                $s_SQLQuery2 .= $s_Separator."'".$this->getEsParaVenta()."'";
                $s_Separator = ", ";
            }
            if ( !is_null( $this->getIdRangoAlquiler() ) )
            {
                $s_SQLQuery1 .= $s_Separator."IdRangoAlquiler";
                $s_SQLQuery2 .= $s_Separator."".$this->getIdRangoAlquiler()."";
                $s_Separator = ", ";
            }
            if ( !is_null( $this->getIdRangoVenta() ) )
            {
                $s_SQLQuery1 .= $s_Separator."IdRangoVenta";
                $s_SQLQuery2 .= $s_Separator."".$this->getIdRangoVenta()."";
                $s_Separator = ", ";
            }
            if ( !is_null( $this->getTieneDescuentoAdelanto() ) )
            {
                $s_SQLQuery1 .= $s_Separator."TieneDescuentoAdelanto";
                $s_SQLQuery2 .= $s_Separator."'".$this->getTieneDescuentoAdelanto()."'";
                $s_Separator = ", ";
            }
            if ( !is_null( $this->getTieneDescuentoContado() ) )
            {
                $s_SQLQuery1 .= $s_Separator."TieneDescuentoContado";
                $s_SQLQuery2 .= $s_Separator."'".$this->getTieneDescuentoContado()."'";
                $s_Separator = ", ";
            }
            if ( !is_null( $this->getIdRangoDescuentoContado() ) )
            {
                $s_SQLQuery1 .= $s_Separator."IdRangoDescuentoContado";
                $s_SQLQuery2 .= $s_Separator."".$this->getIdRangoDescuentoContado()."";
                $s_Separator = ", ";
            }
            if ( !is_null( $this->getIdRengoDescuentoAdelanto() ) )
            {
                $s_SQLQuery1 .= $s_Separator."IdRengoDescuentoAdelanto";
                $s_SQLQuery2 .= $s_Separator."".$this->getIdRengoDescuentoAdelanto()."";
                $s_Separator = ", ";
            }
            if ( !is_null( $this->getEstado() ) )
            {
                $s_SQLQuery1 .= $s_Separator."Estado";
                $s_SQLQuery2 .= $s_Separator."'".$this->getEstado()."'";
                $s_Separator = ", ";
            }
            if ( !is_null( $this->getFechaCreacion() ) )
            {
                $s_SQLQuery1 .= $s_Separator."FechaCreacion";
                $s_SQLQuery2 .= $s_Separator."'".$this->getFechaCreacion()."'";
                $s_Separator = ", ";
            }
             if ( !is_null( $this->getNombreArchivo() ) )
            {
                $s_SQLQuery1 .= $s_Separator."NombreArchivo";
                $s_SQLQuery2 .= $s_Separator."'".$this->getNombreArchivo()."'";
                $s_Separator = ", ";
            }
            if ( !is_null( $this->getUbicacionURL() ) )
            {
                $s_SQLQuery1 .= $s_Separator."UbicacionURL";
                $s_SQLQuery2 .= $s_Separator."'".$this->getUbicacionURL()."'";
                $s_Separator = ", ";
            }
            if ( !is_null( $this->getUbicacionFisica() ) )
            {
                $s_SQLQuery1 .= $s_Separator."UbicacionFisica";
                $s_SQLQuery2 .= $s_Separator."'".$this->getUbicacionFisica()."'";
                $s_Separator = ", ";
            }
            if ( !is_null( $this->getUsuarioCreacion() ) )
            {
                $s_SQLQuery1 .= $s_Separator."UsuarioCreacion";
                $s_SQLQuery2 .= $s_Separator."'".$this->getUsuarioCreacion()."'";
                $s_Separator = ", ";
            }
            if ( !is_null( $this->getFechaModificacion() ) )
            {
                $s_SQLQuery1 .= $s_Separator."FechaModificacion";
                $s_SQLQuery2 .= $s_Separator."'".$this->getFechaModificacion()."'";
                $s_Separator = ", ";
            }
            if ( !is_null( $this->getUsuarioModificacion() ) )
            {
                $s_SQLQuery1 .= $s_Separator."UsuarioModificacion";
                $s_SQLQuery2 .= $s_Separator."'".$this->getUsuarioModificacion()."'";
                $s_Separator = ", ";
            }
            $s_SQLQuery = $s_SQLQuery1." ) ".$s_SQLQuery2." );";
            if( $this->getDebug() ){ pr( $s_SQLQuery ); }
            $o_Resource = Conexion::getConexion();
            $o_Statement = $o_Resource->createStatement();
            $o_Statement->executeQuery( $s_SQLQuery );
        }
        else
        {
            throw new Exception( "El id ya esta registrado." );
        }
        return true;
    }

    /* Actualiza los datos del registro */
    public function update()
    {
        $this->validateRecord();
        if ( true )
        {
            $s_SQLQuery = "UPDATE MST_ClaseSubFamilia SET ";
            $s_Separator = "";
            if ( !is_null( $this->getIdLinea() ) )
            {
                $s_SQLQuery .= $s_Separator."IdLinea = ".$this->getIdLinea()."";
                $s_Separator = ", ";
            }
            if ( !is_null( $this->getIdFamilia() ) )
            {
                $s_SQLQuery .= $s_Separator."IdFamilia = ".$this->getIdFamilia()."";
                $s_Separator = ", ";
            }
            if ( !is_null( $this->getDescripcion() ) )
            {
                $s_SQLQuery .= $s_Separator."Descripcion = '".$this->getDescripcion()."'";
                $s_Separator = ", ";
            }
            if ( !is_null( $this->getUrlAmigable() ) )
            {
                $s_SQLQuery .= $s_Separator."UrlAmigable = '".$this->getUrlAmigable()."'";
                $s_Separator = ", ";
            }
            if ( !is_null( $this->getCodigo() ) )
            {
                $s_SQLQuery .= $s_Separator."Codigo = '".$this->getCodigo()."'";
                $s_Separator = ", ";
            }
            if ( !is_null( $this->getEsParaAlquiler() ) )
            {
                $s_SQLQuery .= $s_Separator."EsParaAlquiler = '".$this->getEsParaAlquiler()."'";
                $s_Separator = ", ";
            }
            if ( !is_null( $this->getEsParaVenta() ) )
            {
                $s_SQLQuery .= $s_Separator."EsParaVenta = '".$this->getEsParaVenta()."'";
                $s_Separator = ", ";
            }
            if ( !is_null( $this->getIdRangoAlquiler() ) )
            {
                $s_SQLQuery .= $s_Separator."IdRangoAlquiler = ".$this->getIdRangoAlquiler()."";
                $s_Separator = ", ";
            }
            if ( !is_null( $this->getIdRangoVenta() ) )
            {
                $s_SQLQuery .= $s_Separator."IdRangoVenta = ".$this->getIdRangoVenta()."";
                $s_Separator = ", ";
            }
            if ( !is_null( $this->getTieneDescuentoAdelanto() ) )
            {
                $s_SQLQuery .= $s_Separator."TieneDescuentoAdelanto = '".$this->getTieneDescuentoAdelanto()."'";
                $s_Separator = ", ";
            }
            if ( !is_null( $this->getTieneDescuentoContado() ) )
            {
                $s_SQLQuery .= $s_Separator."TieneDescuentoContado = '".$this->getTieneDescuentoContado()."'";
                $s_Separator = ", ";
            }
            if ( !is_null( $this->getIdRangoDescuentoContado() ) )
            {
                $s_SQLQuery .= $s_Separator."IdRangoDescuentoContado = ".$this->getIdRangoDescuentoContado()."";
                $s_Separator = ", ";
            }
            if ( !is_null( $this->getIdRengoDescuentoAdelanto() ) )
            {
                $s_SQLQuery .= $s_Separator."IdRengoDescuentoAdelanto = ".$this->getIdRengoDescuentoAdelanto()."";
                $s_Separator = ", ";
            }
            if ( !is_null( $this->getEstado() ) )
            {
                $s_SQLQuery .= $s_Separator."Estado = '".$this->getEstado()."'";
                $s_Separator = ", ";
            }
            if ( !is_null( $this->getFechaCreacion() ) )
            {
                $s_SQLQuery .= $s_Separator."FechaCreacion = '".$this->getFechaCreacion()."'";
                $s_Separator = ", ";
            }
            if ( !is_null( $this->getNombreArchivo() ) )
            {
                $s_SQLQuery .= $s_Separator."NombreArchivo = '".$this->getNombreArchivo()."'";
                $s_Separator = ", ";
            }
            if ( !is_null( $this->getUbicacionURL() ) )
            {
                $s_SQLQuery .= $s_Separator."UbicacionURL = '".$this->getUbicacionURL()."'";
                $s_Separator = ", ";
            }
            if ( !is_null( $this->getUbicacionFisica() ) )
            {
                $s_SQLQuery .= $s_Separator."UbicacionFisica = '".$this->getUbicacionFisica()."'";
                $s_Separator = ", ";
            }
            if ( !is_null( $this->getUsuarioCreacion() ) )
            {
                $s_SQLQuery .= $s_Separator."UsuarioCreacion = '".$this->getUsuarioCreacion()."'";
                $s_Separator = ", ";
            }
            if ( !is_null( $this->getFechaModificacion() ) )
            {
                $s_SQLQuery .= $s_Separator."FechaModificacion = '".$this->getFechaModificacion()."'";
                $s_Separator = ", ";
            }
            if ( !is_null( $this->getUsuarioModificacion() ) )
            {
                $s_SQLQuery .= $s_Separator."UsuarioModificacion = '".$this->getUsuarioModificacion()."'";
                $s_Separator = ", ";
            }
            $s_SQLQuery .= " WHERE  IdSubFamilia = ".$this->getIdSubFamilia().";";
            if( $this->getDebug() ){ pr( $s_SQLQuery ); }

            $o_Resource = Conexion::getConexion();
            $o_Statement = $o_Resource->createStatement();
            $o_Statement->executeQuery( $s_SQLQuery );
        }
        else
        {
            throw new Exception( "El id no esta registrado." );
        }
        return true;
    }

    /* Elimina el registro */
    public function delete()
    {
        $s_SQLQuery = "DELETE FROM MST_ClaseSubFamilia WHERE  IdSubFamilia = ".$this->getIdSubFamilia().";";
        if( $this->getDebug() ){ pr( $s_SQLQuery ); }
        $o_Resource = Conexion::getConexion();
        $o_Statement = $o_Resource->createStatement();
        $o_Statement->executeQuery( $s_SQLQuery );
        return true;
    }

}
?>